package fr.univamu.sorting;

public class SortableIntArray<T extends Comparable<T>> implements Sortable {
    private T[] Array;

    public SortableIntArray(T[] Array){
        this.Array=Array;
    }

    public T[] GetArray(){
        return this.Array;
    }

    public int size(){
        return this.Array.length;
    }
    public T get(int index){
        return this.Array[index];
    }
    public void swap(int index1, int index2){
        T a = this.Array[index1];
        T b = this.Array[index2];
        this.Array[index1] = b;
        this.Array[index2] = a;
    }

    public int compare(int index1, int index2){
        return this.Array[index1].compareTo(this.Array[index1]);
    }

}
