package fr.univamu.sorting;

import java.util.List;

public class SortableIntList<T extends Comparable<T>> implements Sortable {
    private List<T> list;

    public SortableIntList(List<T> list){
        this.list = list;
    }

    public List<T> GetList(){
        return this.list;
    }

    public T get(int index){
        return this.list.get(index);
    }

    public int size(){
        return this.list.size();
    }

    public void swap(int index1, int index2){
        T a = this.list.get(index1);
        T b = this.list.get(index2);
        this.list.add(index2,a);
        this.list.add(index1,b);
    }

    public int compare(int index1, int index2){
        return this.list.get(index1).compareTo(this.list.get(index2));
    }
}
