package fr.univamu.sorting;

import java.util.List;

public class quicksortSort<T extends Comparable<T>> implements Sorter {
    private Sortable Mustsort;

    public quicksortSort(Sortable Mustsort){
        this.Mustsort = Mustsort;
    }

    public Sortable GetSortable(){
        return this.Mustsort;
    }

    private List<List<T>> split(List<T> Tosplit){
        T a = Tosplit.get(Tosplit.size()-1);
        List<T> A = List.of();
        List<T> B = List.of();
        List<T> C = List.of();
        for(T b : Tosplit){
            if (a.compareTo(b)>0){
                A.add(b);
            }
            if (a.compareTo(b)==0){
                C.add(b);
            }
            if (a.compareTo(b)<0){
                B.add(b);
            }
        }
        return List.of(A,C,B);
    }

    private boolean HasRightSize(List<List<T>> Tocheck){
        boolean Truth = true;
        for (List<T> L : Tocheck){
            if (L.size()>1){
                Truth = false;
            }
        }
        return Truth;
    }

    private List<T> Tolist(Sortable S){
        int A = 0;
        List<T> list = List.of();
        while (A<S.size()){
            list.add((T) S.get(A));
            A=A+1;
        }
        return list;
    }

    private void Change(List<T> list){
        int A = 0;
        while (A<list.size()){
            int B = 0;
            while (B<this.Mustsort.size()){
                if (this.Mustsort.get(B) == list.get(A)){
                    this.Mustsort.swap(B, A);
                    B=B+1;
                }
            }
            A=A+1;
        }
    }
    public void sort() {
        List<T> Tosort = Tolist(this.Mustsort);
        List<List<T>> Part = List.of(Tosort);
        boolean Issort = false;
        while (Issort == false){
            List<List<T>> Provpart = List.of();
            for (List<T> L : Part){
                Provpart.addAll(split(L));
            }
            Part=Provpart;
            Issort=HasRightSize(Part);
        }
        List<T> sort=List.of();
        for (List<T> L : Part){
            sort.addAll(L);
        }
        Change(sort);
    }
}
