package fr.univamu.sorting;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class IntLists {
  private static final long SEED = 129874;
  private final static Random random = new Random(SEED);

  public static List<Integer> range(int mini, int maxi) {
    List<Integer> range = new ArrayList<>(maxi - mini + 1);
    for (int i = mini; i <= maxi; i++) {
      range.add(i);
    }
    return range;
  }

  public static List<Integer> shuffledRange(int mini, int maxi) {
    List<Integer> shuffled = range(mini, maxi);
    for (int i = 0; i < shuffled.size()-1; i++) {
      int j = IntLists.random.nextInt(i,shuffled.size());
      int tmp = shuffled.get(i);
      shuffled.set(i,shuffled.get(j));
      shuffled.set(j,tmp);
    }
    return shuffled;
  }
}
