package fr.univamu.sortvisualization;

import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.stage.Stage;

import java.io.IOException;

public class Application extends javafx.application.Application {

  @Override
  public void start(Stage stage) throws IOException {
    FXMLLoader fxmlLoader = new FXMLLoader(Application.class.getResource("view.fxml"));
    Scene scene = new Scene(fxmlLoader.load(), Controller.WIDTH, Controller.HEIGHT);
    stage.setTitle("Visualize sorting algorithms");
    stage.setScene(scene);
    stage.show();
  }

  public static void main(String[] args) {
    launch();
  }
}