package fr.univamu.sortvisualization;

import javafx.application.Platform;
import javafx.scene.chart.XYChart;

public class TimeDataSeries implements DataSeries {

  private final XYChart.Series<Number,Number> series;

  public TimeDataSeries(XYChart.Series<Number, Number> series) {
    this.series = series;
  }

  @Override
  public void add(double x, double y) {
    Platform.runLater( () ->
        series.getData().add(new XYChart.Data<>(x,y))
    );
  }
}
